/*-----------------------------------------------------------------------------
Copyright (C) Sylvain Fourmanoit <syfou@users.sourceforge.net>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies of the Software and its documentation and acknowledgment shall be
given in the documentation and software packages that this Software was
used.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.   
------------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
#ifndef HAVE_EDESKLETS_H
#define HAVE_EDESKLETS_H

#ifndef HAVE_CONFIG_H
#error autogenerated config.h not included
#else
#include "config.h"	/* Autoconf header */
#endif

#include <glib.h>
#include <gtk/gtk.h>

#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#include "gettext.h"
#define _(string) gettext(string)

/*---------------------------------------------------------------------------*/
typedef struct _LFILE LFILE;

typedef struct _Desklet {
  gchar * id;
  gchar * uri;
  gint x, y, width, height;
  gboolean decorate;
  gint timeout, attempts;
} Desklet;

typedef struct _EConfig {
  gboolean crashmode;
  gchar  * crashmsg;

  GArray * desklets;

  GKeyFile * kf;
  LFILE * lf;
} EConfig;

/*---------------------------------------------------------------------------*/
typedef enum _EError {
  EERROR_UNDEFINED,
  EERROR_SYSTEM,
  EERROR_ALREADY_LOCKED
} EError;

/*---------------------------------------------------------------------------*/
extern const Desklet DESKLET_DEFAULTS;
extern const GQuark * EDOMAIN;

/*---------------------------------------------------------------------------*/
void      error_init(void);
char *    error_system(void);

void      icons_init(void);

gchar *   id_generate(void);

void      dialog_error(GtkWidget * parent, gchar * msg);
void      dialog_warning(GtkWidget * parent, gchar * msg);
gboolean  dialog_yesno(GtkWidget * parent, gchar * msg);

gchar *   config_path(gchar * basename);
void      config_default(Desklet * desc);
EConfig * config_load(gboolean  nolock, gboolean readonly);
gint      config_merge(EConfig * conf, Desklet * desc);
void      config_dump(EConfig ** conf);

FILE *    file(LFILE * f);
LFILE *   fopen_locked(gchar * filename, gchar * mode, 
		       gboolean lock, gboolean block,
		       GError ** error);
void      fclose_locked(LFILE ** lf, 
			GError ** error);

void      misc_set_tooltip(GtkWidget * widget, const gchar * text);

void      launch_register(gboolean nolock);
void      launch_killall(gboolean nolock);
void      launch_killall_external(gchar * fullname, gboolean nolock);
void      launch_all(gchar * fullname, gboolean nolock);
void      launch_all_external(gchar * fullname, gboolean nolock);

gchar *   about_text(void);
void      about_dialog(GtkWidget * parent);

void      prefs_dialog(GtkWidget * parent, gchar * fullname,
		       Desklet * desc, gboolean nolock);

void      webkit_launch(gchar * fullname, Desklet * desc, gboolean nolock);

/*---------------------------------------------------------------------------*/
#endif
